/*
    Video2P -- video hosting engine for I2P network.
    Copyright (C) 2023 - 2025 Video2P Team

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef VIDEO2P_STRING_HPP
#define VIDEO2P_STRING_HPP

#include <stddef.h>

#include "memory.hpp"

class V2PString {
private:
	char *m_str;
	size_t m_size;

public:
	V2PString() throw();
	V2PString(const char *str) throw(V2PAllocatorException);
	V2PString(const V2PString &other) throw(V2PAllocatorException);
	V2PString &operator=(const V2PString &other) throw(
	    V2PAllocatorException);
	~V2PString() throw();
	const char *get() const throw();
	size_t getSize() const throw();

private:
	char *m_alloc(size_t size) throw(V2PAllocatorException);
};

#endif // VIDEO2P_STRING_HPP
